/* $Id: ast_ehandler.h 6310 2023-01-16 20:39:48Z aron $ */
/*
    Welltype parser and AST
    Copyright (C) 2014-2023  Aron Barath

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef WTPARSER_AST_EHANDLER_H
#define WTPARSER_AST_EHANDLER_H

#include "../astnode.h"
#include <string>

namespace wtast
{

class Compound;

class EHandler : public AstNode
{
	std::string mName;
	Compound*   mBody;

public:
	EHandler(const std::string & name, Compound* c)
		: AstNode()
		, mName(name)
		, mBody(c)
	{
		// ok
	}

	~EHandler();

	void Accept(AstVisitor* vis);

	EHandler* Copy();

	Kind GetKind() const
	{
		return EHANDLER;
	}

	std::string & GetName()
	{
		return mName;
	}

	Compound* GetBody()
	{
		return mBody;
	}
};

} // namespace wtast

#endif // WTPARSER_AST_EHANDLER_H

